type clazz
type iface
type tyvar
type field
type meth 
type var  
type unknown

val mk_class : string -> clazz
val mk_iface : string -> iface
val mk_tyvar : string -> tyvar
val mk_field : string -> field
val mk_meth : string -> meth
val mk_var : string -> var 
val mk_unknown : string -> unknown

val string_from_class : clazz -> string
val string_from_iface : iface -> string
val string_from_tyvar : tyvar -> string
val string_from_field : field -> string
val string_from_var : var -> string
val string_from_meth : meth -> string
val string_from_unknown : unknown -> string

val cmp_class : clazz -> clazz -> int
val cmp_iface : iface -> iface -> int
val cmp_tyvar : tyvar -> tyvar -> int
val cmp_field : field -> field -> int
val cmp_meth : meth -> meth -> int
val cmp_var : var -> var -> int

val fresh_var : var -> var
val fresh_tyvar : tyvar -> tyvar

val pp_clazz : clazz -> bool -> unit 
val pp_iface : iface -> bool -> unit
val pp_tyvar : tyvar -> bool -> unit
val pp_field : field -> bool -> unit
val pp_meth : meth -> bool -> unit
val pp_var : var -> bool -> unit
val pp_unknown : unknown -> bool -> unit
